<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): Graph Generation</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">Graph Generation</div>  </div>
</div><!--header-->
<div class="contents">

<p>routines for graph generation and handling.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ga154582cde79938a8ab8fa4423842c1cd"><td class="memTemplParams" colspan="2">template&lt;typename VertexClass &gt; </td></tr>
<tr class="memitem:ga154582cde79938a8ab8fa4423842c1cd"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group__graph__gen.html#ga154582cde79938a8ab8fa4423842c1cd">tiglGenerationConstructGraphRmat</a> (typename VertexClass::ID_TYPE numVertices, long meanNumEdges, vector&lt; VertexClass &gt; &amp;vertexList, double a=0.25, double b=0.25, double c=0.25, double d=0.25, bool isDirected=true, typename VertexClass::ID_TYPE startID=0)</td></tr>
<tr class="memdesc:ga154582cde79938a8ab8fa4423842c1cd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Graph construction using the R-mat procedure.  <a href="#ga154582cde79938a8ab8fa4423842c1cd">More...</a><br /></td></tr>
<tr class="separator:ga154582cde79938a8ab8fa4423842c1cd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gae3194a7e094fc2e1084b86d829927e55"><td class="memTemplParams" colspan="2">template&lt;typename GraphClass &gt; </td></tr>
<tr class="memitem:gae3194a7e094fc2e1084b86d829927e55"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group__graph__gen.html#gae3194a7e094fc2e1084b86d829927e55">tiglGenerationConstructGraphRmat</a> (typename GraphClass::ID_TYPE numVertices, long meanNumEdges, GraphClass &amp;graph, double a=0.25, double b=0.25, double c=0.25, double d=0.25)</td></tr>
<tr class="memdesc:gae3194a7e094fc2e1084b86d829927e55"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaed version of graph construction using the R-mat procedure.  <a href="#gae3194a7e094fc2e1084b86d829927e55">More...</a><br /></td></tr>
<tr class="separator:gae3194a7e094fc2e1084b86d829927e55"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga3c3207201da97886569a8f1bb4d7d99f"><td class="memTemplParams" colspan="2">template&lt;typename VertexClass &gt; </td></tr>
<tr class="memitem:ga3c3207201da97886569a8f1bb4d7d99f"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group__graph__gen.html#ga3c3207201da97886569a8f1bb4d7d99f">tiglGenerationGenerateEdgeList</a> (vector&lt; VertexClass &gt; &amp;verticesList, vector&lt; typename VertexClass::EDGE_TYPE &gt; &amp;edgeList)</td></tr>
<tr class="memdesc:ga3c3207201da97886569a8f1bb4d7d99f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Generating edge list from vertices list.  <a href="#ga3c3207201da97886569a8f1bb4d7d99f">More...</a><br /></td></tr>
<tr class="separator:ga3c3207201da97886569a8f1bb4d7d99f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaaf06b5f7ff4e33691bce745642e43c65"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__graph__gen.html#gaaf06b5f7ff4e33691bce745642e43c65">tiglGenerationPartitionGraph</a> (char *fileName, uint_fast32_t numPartitions)</td></tr>
<tr class="memdesc:gaaf06b5f7ff4e33691bce745642e43c65"><td class="mdescLeft">&#160;</td><td class="mdescRight">Partitions a graph to subgraphs with equal number of vertices.  <a href="#gaaf06b5f7ff4e33691bce745642e43c65">More...</a><br /></td></tr>
<tr class="separator:gaaf06b5f7ff4e33691bce745642e43c65"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga93964f0463f89fd2490b88fc4515b8ef"><td class="memTemplParams" colspan="2">template&lt;typename CVertex &gt; </td></tr>
<tr class="memitem:ga93964f0463f89fd2490b88fc4515b8ef"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group__graph__gen.html#ga93964f0463f89fd2490b88fc4515b8ef">tiglGenerationRemoveSelfCycles</a> (vector&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt; &amp;verticesList)</td></tr>
<tr class="memdesc:ga93964f0463f89fd2490b88fc4515b8ef"><td class="mdescLeft">&#160;</td><td class="mdescRight">Removes from the graph all length-1 cycles.  <a href="#ga93964f0463f89fd2490b88fc4515b8ef">More...</a><br /></td></tr>
<tr class="separator:ga93964f0463f89fd2490b88fc4515b8ef"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>routines for graph generation and handling. </p>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="ga154582cde79938a8ab8fa4423842c1cd"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename VertexClass &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void tiglGenerationConstructGraphRmat </td>
          <td>(</td>
          <td class="paramtype">typename VertexClass::ID_TYPE&#160;</td>
          <td class="paramname"><em>numVertices</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">long&#160;</td>
          <td class="paramname"><em>meanNumEdges</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">vector&lt; VertexClass &gt; &amp;&#160;</td>
          <td class="paramname"><em>vertexList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>a</em> = <code>0.25</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>b</em> = <code>0.25</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>c</em> = <code>0.25</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>d</em> = <code>0.25</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>isDirected</em> = <code>true</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">typename VertexClass::ID_TYPE&#160;</td>
          <td class="paramname"><em>startID</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Graph construction using the R-mat procedure. </p>
<p>The procedure built a template graph using the R-mat procedure as outlined in the paper: D. Chakrabarti, Y. Zhan, C. Faloutsos, "R-MAT: a recursive model for graph Mining"</p>
<p>Inputs: </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">numVertices</td><td>total number of vertices in the output graph </td></tr>
    <tr><td class="paramname">meanNumEdges</td><td>the mean of the number of output edges per vertex </td></tr>
    <tr><td class="paramname">isDirected</td><td>a flag which is set to "true" if the graph is directed, otherwise it is set to "false" </td></tr>
    <tr><td class="paramname">vertexList</td><td>output vector of all the vertices in the graph </td></tr>
    <tr><td class="paramname">a,b,c,d</td><td>probability parameters that governs the graph generation algorithm </td></tr>
    <tr><td class="paramname">startID</td><td>starting value of the key of the graph vertices </td></tr>
  </table>
  </dd>
</dl>
<p><b>Procedure</b> </p>
<ol type="1">
<li>Allocating enough memory to the vertex list and assigning default keys to them</li>
<li>Loop for generating edge, one at a time until the target number of edges is reached. Execute the following for each new edge</li>
<li>Loop to compute the x-y position of the edge in the incidence matrix</li>
<li>if an edge already exists ignore this edge</li>
<li>Attach the new edge to the corresponding vertex (or vertices)</li>
<li>If the vertex has input edge buffer, add the new edge to the input buffer of the target vertex </li>
</ol>

</div>
</div>
<a class="anchor" id="gae3194a7e094fc2e1084b86d829927e55"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename GraphClass &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void tiglGenerationConstructGraphRmat </td>
          <td>(</td>
          <td class="paramtype">typename GraphClass::ID_TYPE&#160;</td>
          <td class="paramname"><em>numVertices</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">long&#160;</td>
          <td class="paramname"><em>meanNumEdges</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">GraphClass &amp;&#160;</td>
          <td class="paramname"><em>graph</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>a</em> = <code>0.25</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>b</em> = <code>0.25</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>c</em> = <code>0.25</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>d</em> = <code>0.25</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaed version of graph construction using the R-mat procedure. </p>
<p>Inputs: </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">numVertices</td><td>total number of vertices in the output graph </td></tr>
    <tr><td class="paramname">meanNumEdges</td><td>the mean of the number of output edges per vertex </td></tr>
    <tr><td class="paramname">graph</td><td>a subgraph class that contains the vertexList </td></tr>
    <tr><td class="paramname">a,b,c,d</td><td>probability parameters that governs the graph generation algorithm </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga3c3207201da97886569a8f1bb4d7d99f"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename VertexClass &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void tiglGenerationGenerateEdgeList </td>
          <td>(</td>
          <td class="paramtype">vector&lt; VertexClass &gt; &amp;&#160;</td>
          <td class="paramname"><em>verticesList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">vector&lt; typename VertexClass::EDGE_TYPE &gt; &amp;&#160;</td>
          <td class="paramname"><em>edgeList</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Generating edge list from vertices list. </p>
<p><b>Procedure</b> </p><ol type="1">
<li>Reading the output edges from each vertex and pushing it to the edge list</li>
<li>sorting the the edges based on the ID </li>
</ol>

</div>
</div>
<a class="anchor" id="gaaf06b5f7ff4e33691bce745642e43c65"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool tiglGenerationPartitionGraph </td>
          <td>(</td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>fileName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>numPartitions</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Partitions a graph to subgraphs with equal number of vertices. </p>
<p>The original graph is stored in a file, and the partitioned filenames are derived from the original file name. If the original file is name is &lt;name&gt;.&lt;ext&gt;, the partititoned file names are: &lt;name&gt;_0.&lt;ext&gt;, &lt;name&gt;_1.&lt;ext&gt;, ... </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">fileName</td><td>file name of the file that contains the adjacency list of the graph </td></tr>
    <tr><td class="paramname">numPartitions</td><td>number of partitions </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if success, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="ga93964f0463f89fd2490b88fc4515b8ef"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void tiglGenerationRemoveSelfCycles </td>
          <td>(</td>
          <td class="paramtype">vector&lt; <a class="el" href="classTIGLContainersVertexBase.html">CVertex</a> &gt; &amp;&#160;</td>
          <td class="paramname"><em>verticesList</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Removes from the graph all length-1 cycles. </p>
<p>Removes all edges that results in cycles of length 1 (i.e., source and target nodes are the same) This is in-place procedure, </p>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:52 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
